//package AFDX;

import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Properties;
import java.util.Random;
public class OurMethod {
	public static int FPNFP(List<Integer> hp, List<Integer> ep, List<Integer> lp, int[] pSize, double[] period, double[] jitter, int i, double R) {
		int res = 0;
		boolean flag = true;
		List<Integer> l = new ArrayList<>();
		int k = hp.size();
		for(int j=0;j<k;j++) {
			l.add(1);
		}
		double J = jitter[i];
		double ipJ = 0;
		int mSize = 0;
		for(int j=0;j<k;j++) {
			res = res+pSize[hp.get(j)];
			J=Math.min(J,jitter[hp.get(j)]);
		}
		for(int j=0;j<lp.size();j++) {
			if(pSize[lp.get(j)] > mSize) {
				mSize = pSize[lp.get(j)];
				ipJ = jitter[lp.get(j)];
				
			}
		}
		res = res+mSize;
		for(int j=0;j<ep.size();j++) {
			res = res+pSize[ep.get(j)];
			J=Math.min(J,jitter[ep.get(j)]);
		}
		J = Math.max(J, ipJ);
		
		while(flag) {
			flag = false;
			int j = 0;
			
			while(j<k) {
				if((double)res*8.0/R+J > period[hp.get(j)]*(l.get(j))){
					flag = true;
					l.set(j,l.get(j)+1);
					res = res+pSize[hp.get(j)];
				}
				j = j+1;
			}
			
		}
		return res;		
	}
	public static int FPFP(List<Integer> hp, List<Integer> ep, List<Integer> lp, int[] pSize, double[] period, double[] jitter, int i, double R) {
		int res = pSize[i];
		boolean flag = true;
		List<Integer> l = new ArrayList<>();
		int k = hp.size();
		for(int j=0;j<k;j++) {
			l.add(1);
		}
		double J = jitter[i];
		for(int j=0;j<k;j++) {
			res = res+pSize[hp.get(j)];
			J=Math.min(J,jitter[hp.get(j)]);
		}
		for(int j=0;j<ep.size();j++) {
			res = res+pSize[ep.get(j)];
			J=Math.min(J,jitter[ep.get(j)]);
		}
		//System.out.println("res: "+i+": "+res);
		while(flag) {
			flag = false;
			int j = 0;		
			while(j<k) {
				if((double)res*8.0/R+J > period[hp.get(j)]*(l.get(j))){
					flag = true;
					l.set(j,l.get(j)+1);
					res = res+pSize[hp.get(j)];
				}
				j = j+1;
			}		
		}
		return res-pSize[i];		
	}
	public static void findSets(int[] priority, List<Integer> hp, List<Integer> ep, List<Integer> lp, int i) {
		int m = priority.length;
		for(int j=0;j<m;j++) {
			if(j==i) continue;
			if(priority[j]<priority[i]) {
				lp.add(j);
			}else if (priority[j] == priority[i]) {
				ep.add(j);
			}else {
				hp.add(j);
			}
		}
	}


	public static double[] getDelay1(int[] priority, int[] pSize, double[] period, double[] delayR, double[] jitter, double R, double T, double c) {
		int m = priority.length;
		double[] delay = new double[m];
		for(int i=0;i<m;i++) {
			List<Integer> hp = new ArrayList<>();
			List<Integer> ep = new ArrayList<>();
			List<Integer> lp = new ArrayList<>();
			findSets(priority,hp,ep,lp,i);			
			int res = FPNFP(hp, ep, lp, pSize, period, jitter, i, R);
//			if(i == 7) System.out.println(res*8);
			delay[i] = (R*T+(double)res*8+(double)pSize[i]*8)/R;
			//System.out.println(delay[i]);
		}
		return delay;		
	}
	public static void writeArrayToExcel(double[] data, String string) {
        int rowNum = data.length;

        try {
            FileWriter fw = new FileWriter(string);
            for (int i = 0; i < rowNum; i++) {
                fw.write(data[i]+ "\n"); // tab 
            }
            fw.close();
        }
        catch (IOException e){
            e.printStackTrace();
        }

    }

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		int numVL = 100;
		for(numVL = 100;numVL<=100;numVL=numVL+100) {
			int[] priority = new int[numVL];
			double[] BAG = {2, 4, 8, 16, 32, 64, 128};
			int[] size = {32, 64, 128, 256, 512, 1024, 1500};
			int numP = 2;
	        for(int i=0;i<priority.length;i++) {
	        	Random rand = new Random();
	        	priority[i] = i%numP;
//	        	System.out.println(priority[i]);
	        }
			double[] period = new double[numVL];
			double[] jitter =  new double[numVL];
			for(int i=0;i<priority.length;i++) {
				if(i<numVL/2) {
					period[i] = BAG[2]/1000;
				}else {
					period[i] = BAG[3]/1000;
				}
	        	
			}
			int[] pSize = new int[numVL];
			for(int i=0;i<numVL;i++) {
				pSize[i] = size[i%7];
			}
			double[] delayR = new double[numVL];
			for(int i=0;i<numVL;i++) {
				delayR[i] = pSize[i]/64/250;
			}
			double R = 500000*200;
			double T = 0.001;
			double c = 100;
			double[] delay = getDelay1(priority, pSize, period, delayR, jitter, R, T, c);
			for(int i=0;i<numVL;i++) {
				System.out.println(delay[i]);
			}
	        writeArrayToExcel(delay,numVL+"diffO.csv"); 
			
		}
		
	}

}
