//package AFDX;

import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import java.util.Arrays;
import java.util.List;
import java.util.Random;

class ServiceCurve{
	double rate;
	double T;
	public ServiceCurve(double rate, double T) {
		this.rate = rate;	
		this.T = T;
	}
	public double getRate(){
		return rate;
	}
	public double getT(){
		return T;
	}
	public void reduceRate(double alpha) {
		double temp = this.rate*this.T;
		this.rate = this.rate-alpha;
		this.T = temp/this.rate;
		
	}
	public void increaseT(double burst) {
		double temp = this.T*this.rate;
		temp = temp+burst;
		this.T = temp/this.rate;
		
	}
	public double getDelay(double burst) {
		double delay = (burst+this.rate*this.T)/this.rate;
		return delay;
	}
	
}
public class PreviousMethod {

	public static double NFP(List<Integer> hp, List<Integer> ep, List<Integer> lp, int[] pSize, double[] period, double[] jitter, int i, double R, double T) {
		double sum = 0;
		double mSize = 0;
		ServiceCurve sc = new ServiceCurve(R,T);
		for(int j = 0;j<ep.size();j++) {
			double rate = (double)(pSize[ep.get(j)])*8.0/period[ep.get(j)];
			double burst = (double)(pSize[ep.get(j)])*8;
			sc.reduceRate(rate);
			sc.increaseT(burst);
			if(i == 7) {
				System.out.println("burst: "+burst/8);
			}
			sum = sum+rate;
		}
		for(int j = 0;j<hp.size();j++) {
			double rate = (double)(pSize[hp.get(j)])*8.0/period[hp.get(j)];
			double burst = (double)(pSize[hp.get(j)])*8;
			sc.reduceRate(rate);
			sc.increaseT(burst);
			sum = sum+rate;
		}
		for(int j=0;j<lp.size();j++) {
			if(pSize[lp.get(j)]>mSize) {
				mSize = pSize[lp.get(j)];
			}
		}
		sc.increaseT(mSize*8);
		if(i == 7) {
			System.out.println(sc.rate*sc.T);
			System.out.println(sc.T);
		}
		
	    double delay = sc.getDelay(pSize[i]*8);
		return delay;		
	}
	public static double FP(List<Integer> hp, List<Integer> ep, List<Integer> lp, int[] pSize, double[] period, double[] jitter, int i, double R, double T) {
		int m = pSize.length;
		ServiceCurve sc = new ServiceCurve(R,T);
		for(int j = 0;j<ep.size();j++) {
			double rate = (double)(pSize[ep.get(j)])*8.0/period[ep.get(j)];
			double burst = (double)(pSize[ep.get(j)])*8;
			sc.reduceRate(rate);
			sc.increaseT(burst);
		}
		for(int j = 0;j<hp.size();j++) {
			double rate = (double)(pSize[hp.get(j)])*8.0/period[hp.get(j)];
			double burst = (double)(pSize[hp.get(j)])*8;
			sc.reduceRate(rate);
			sc.increaseT(burst);
		}

	    double delay = sc.getDelay(pSize[i]*8);
		return delay;		
	}
	public static void findSets(int[] priority, List<Integer> hp, List<Integer> ep, List<Integer> lp, int i) {
		int m = priority.length;
		for(int j=0;j<m;j++) {
			if(j==i) continue;
			if(priority[j]<priority[i]) {
				lp.add(j);
			}else if (priority[j] == priority[i]) {
				ep.add(j);
			}else {
				hp.add(j);
			}
		}
	}

	public static double[] getDelay(int[] priority, int[] pSize, double[] period, double[] delayR, double[] jitter, double R, double T, double c) {
		int m = priority.length;
		double[] delay = new double[m];
		for(int i=0;i<m;i++) {
			List<Integer> hp = new ArrayList<>();
			List<Integer> ep = new ArrayList<>();
			List<Integer> lp = new ArrayList<>();
			findSets(priority,hp,ep,lp,i);			
			double res = FP(hp, ep, lp, pSize, period, jitter, i, R, T);	
			delay[i] = res;
			//System.out.println(delay[i]);
		}
		return delay;		
	}	
	public static void writeArrayToExcel(double[] data, String string) {
        int rowNum = data.length;
        try {
            FileWriter fw = new FileWriter(string);
            for (int i = 0; i < rowNum; i++) {
                fw.write(data[i]+ "\n"); // tab 
            }
            fw.close();
        }
        catch (IOException e){
            e.printStackTrace();
        }

    }
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		int numVL = 20;
		for(numVL = 20;numVL<=20;numVL=numVL+20) {
			int[] priority = new int[numVL];
			double[] BAG = {2, 4, 8, 16, 32, 64, 128};
			int[] size = {32, 64, 128, 256, 512, 1024, 1500};
			int numP = 8;
	        for(int i=0;i<priority.length;i++) {
	        	Random rand = new Random();
	        	priority[i] = i%1;
	        }
			double[] period = new double[numVL];
			double[] jitter =  new double[numVL];
			for(int i=0;i<priority.length;i++) {
				if(i<numVL/2) {
					period[i] = BAG[2]/1000;
				}else {
					period[i] = BAG[3]/1000;
				}
	        	
			}
			int[] pSize = new int[numVL];
			for(int i=0;i<numVL;i++) {
				pSize[i] = size[i%7];
			}
			double[] delayR = new double[numVL];
			for(int i=0;i<numVL;i++) {
				delayR[i] = pSize[i]/64/250;
			}
			double R = 500000*200;
			double T = 0.001;
			double c = 100;
//			ServiceCurve sc = new ServiceCurve(R,T);
//			sc.reduceRate(1000000);
//			System.out.println(sc.getRate());
//			System.out.println(sc.getT());

			double[] delay = getDelay(priority, pSize, period, delayR, jitter, R, T, c);
			for(int i=0;i<numVL;i++) {
				System.out.println(delayR[i]);
			}
			writeArrayToExcel(delay,numVL+"diffP.csv");
			
		}
		
	}

}
