package AFDX;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

public class test {
	public static int FPNFP(List<Integer> hp, List<Integer> ep, List<Integer> lp, int[] pSize, double[] period, double[] jitter, int i, double R) {
		int res = 0;
		boolean flag = true;
		List<Integer> l = new ArrayList<>();
		int k = hp.size();
		for(int j=0;j<k;j++) {
			l.add(1);
		}
		double J = jitter[i];
		double ipJ = 0;
		int mSize = 0;
		for(int j=0;j<k;j++) {
			res = res+pSize[hp.get(j)];
			J=Math.min(J,jitter[hp.get(j)]);
		}
		for(int j=0;j<lp.size();j++) {
			if(pSize[lp.get(j)] > mSize) {
				mSize = pSize[lp.get(j)];
				ipJ = jitter[lp.get(j)];
				
			}
		}
		res = res+mSize;
		for(int j=0;j<ep.size();j++) {
			res = res+pSize[ep.get(j)];
			J=Math.min(J,jitter[ep.get(j)]);
		}
		J = Math.max(J, ipJ);
		//System.out.println("res: "+i+": "+res);
		while(flag) {
			flag = false;
			int j = 0;
			
			while(j<k) {
				if((double)res*8.0/R+J > period[hp.get(j)]*(l.get(j))){
					flag = true;
					l.set(j,l.get(j)+1);
					res = res+pSize[hp.get(j)];
				}
				j = j+1;
			}
			
		}
		return res;		
	}
	public static int FPFP(List<Integer> hp, List<Integer> ep, List<Integer> lp, int[] pSize, double[] period, double[] jitter, int i, double R) {
		int res = pSize[i];
		boolean flag = true;
		List<Integer> l = new ArrayList<>();
		int k = hp.size();
		for(int j=0;j<k;j++) {
			l.add(1);
		}
		double J = jitter[i];
		for(int j=0;j<k;j++) {
			res = res+pSize[hp.get(j)];
			J=Math.min(J,jitter[hp.get(j)]);
		}
		for(int j=0;j<ep.size();j++) {
			res = res+pSize[ep.get(j)];
			J=Math.min(J,jitter[ep.get(j)]);
		}
		//System.out.println("res: "+i+": "+res);
		while(flag) {
			flag = false;
			int j = 0;		
			while(j<k) {
				if((double)res*8.0/R+J > period[hp.get(j)]*(l.get(j))){
					flag = true;
					l.set(j,l.get(j)+1);
					res = res+pSize[hp.get(j)];
				}
				j = j+1;
			}		
		}
		return res-pSize[i];		
	}
	public static void findSets(int[] priority, List<Integer> hp, List<Integer> ep, List<Integer> lp, int i) {
		int m = priority.length;
		for(int j=0;j<m;j++) {
			if(j==i) continue;
			if(priority[j]<priority[i]) {
				lp.add(j);
			}else if (priority[j] == priority[i]) {
				ep.add(j);
			}else {
				hp.add(j);
			}
		}
	}
	public static double penalty(double[] delay, double[] delayR, double c) {
		double res = 0;
		for(int i=0;i<delay.length;i++) {
			if(delay[i]>delayR[i]) {
				res = res+c*Math.max(0, (delay[i]-delayR[i]));
			}
		}
		return res;
	}
	public static double getPenalty(int[] priority, int[] pSize, double[] period, double[] delayR, double[] jitter, double R, double T, double c, int flag) {
		int m = priority.length;
		double[] delay = new double[m];
		for(int i=0;i<m;i++) {
			List<Integer> hp = new ArrayList<>();
			List<Integer> ep = new ArrayList<>();
			List<Integer> lp = new ArrayList<>();
			findSets(priority,hp,ep,lp,i);	
			int res = 0;
			if(flag == 1) {
				res = FPFP(hp, ep, lp, pSize, period, jitter, i, R);
			}else {
				res = FPNFP(hp, ep, lp, pSize, period, jitter, i, R);
			}
			//System.out.println("numVL: "+m+" "+res);	
			delay[i] = (R*T+(double)res*8+(double)pSize[i]*8)/R;
		}
		double res = penalty(delay, delayR, c);
		return res;		
	}
	public static void main(String[] args) {
		// TODO Auto-generated method stub.
		
		for(int numVL = 100;numVL>=20;numVL=numVL-10) {
			int[] priority = new int[numVL];
			double[] BAG = {2, 4, 8, 16, 32, 64, 128};
			int[] size = {32, 64, 128, 256, 512, 1024, 1500};
			for(int i=0;i<numVL;i++) {
	        	priority[i] = i%8;
	        }
			

	        
			double[] period = new double[numVL];
			double[] jitter =  new double[numVL];
			for(int i=0;i<priority.length;i++) {
	        	period[i] = BAG[i%7]/1000;
	        	
			}
			int[] pSize = new int[numVL];
			for(int i=0;i<numVL;i++) {
				pSize[i] = size[i%7];
			}
			double[] delayR = new double[numVL];
			for(int i=0;i<numVL;i++) {
				delayR[i] = (double)pSize[i]/64/5000;
			}
			List<Integer> hp = new ArrayList<>();
			List<Integer> lp = new ArrayList<>();
			List<Integer> ep = new ArrayList<>();
			findSets(priority,hp,ep, lp, 1);

			double res = getPenalty( priority, pSize, period, delayR,jitter, 30000000,  0.001, 100, 0);
			System.out.println("numVL: "+numVL+" "+res);
			
			
		}	

	}

}
