#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Apr 26 13:41:19 2022

@author: boyang
"""

import dpkt	
import os
import datetime
from scapy.all import *
src = '172.31.192.85'
dest = '172.31.190.182'
protocol = 'UDP'
senderFile = 'Sender.pcap'
receiverFile = 'Receiver.pcap'

# rdpcap comes from scapy and loads in our pcap file
def calArrivalCurve(file,source,destination,protocol):
    packets = rdpcap(file)
    tsList = []
    sizeList= []
    # Let's iterate through every packet
    for packet in packets:
        # We're only interested packets with a DNS Round Robin layer+
        
        if(protocol in packet.summary()):
        
            size = len(packet)
            #print(packet.summary(),size)
            # print(size)
            src = packet[IP].src
            dst = packet[IP].dst
            ts = packet.time
            # print(src)
            # print(dst)
            if(src == source and dst == destination):
                tsList.append(ts)
                sizeList.append(size)
    s = sum(sizeList)
    start = tsList[0]
    end = tsList[-1]
    rate = s/(end-start)
    burst = max(sizeList)
    sizeSum = []
    for i in range(len(sizeList)):
        if(len(sizeSum) == 0):
            sizeSum.append(sizeList[0])
        else:
            sizeSum.append(sizeSum[-1]+sizeList[i])
        
    
    for i in range(len(sizeList)):
        for j in range((i+1),len(sizeList)):
            burst = max(burst, (sizeSum[j]-sizeSum[i])-rate*(tsList[j]-tsList[i]))
    print("rate: ", rate*8)
    print("burst: ",burst*8)
    return rate,burst


def calServiceCurve(senderFile,receiverFile,source,destination,protocol,rate):
    packets = rdpcap(senderFile)
    packets1 = rdpcap(receiverFile)
    tsList = []
    sizeList= []
    tsList1 = []
    sizeList1= []
    # Let's iterate through every packet
    for packet in packets:
        # We're only interested packets with a DNS Round Robin layer
        if(protocol in packet.summary()):
            size = len(packet)
            # print(size)
            src = packet[IP].src
            dst = packet[IP].dst
            ts = packet.time
            # print(src)
            # print(dst)
            if(src == source and dst == destination):
                tsList.append(ts)
                sizeList.append(size)
    for packet in packets1:
        # We're only interested packets with a DNS Round Robin layer
        if(protocol in packet.summary()):
            size = len(packet)
            # print(size)
            src = packet[IP].src
            dst = packet[IP].dst
            ts = packet.time
            # print(src)
            # print(dst)
            if(src == source and dst == destination):
                tsList1.append(ts)
                sizeList1.append(size)
    sizeSum = []
    sizeSum1 = []
    for i in range(len(sizeList)):
        if(len(sizeSum) == 0):
            sizeSum.append(sizeList[0])
        else:
            sizeSum.append(sizeSum[-1]+sizeList[i])
    
    for i in range(len(sizeList1)):
        if(len(sizeSum1) == 0):
            sizeSum1.append(sizeList1[0])
        else:
            sizeSum1.append(sizeSum1[-1]+sizeList1[i])
    
    left = 0
    right = 1
    while(right-left>=0.0001):
        mid = (right+left)/2

        flag = False
        for i in range(len(sizeSum1)):
            inf = float('inf')
            for j in range(len(sizeSum)):
                if(tsList[j]>tsList1[i]):
                    break
                timeDiff = tsList1[i]-tsList[j]
                inf = min(inf,sizeSum[j]*8+rate*(timeDiff-mid))
            if(sizeSum1[i] <= inf):
                flag = True
                break
        if(flag):
            left = mid
        else:
            right = mid
        print("left: ",left)
        print("right: ",right)
        
    print("latency: ",right)
    return right

calArrivalCurve(senderFile, src, dest, 'UDP')  
rate = 16000000000
calServiceCurve(senderFile,receiverFile,src,dest,'UDP',rate) 
        # print(len(packet))
        # print(packet.time)
        # print(packet[IP].src)
        # print(packet[IP].dst)
    
