package implementation;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.networkcalculus.dnc.AnalysisConfig;
import org.networkcalculus.dnc.AnalysisConfig.ArrivalBoundMethod;
import org.networkcalculus.dnc.AnalysisConfig.MaxScEnforcement;
import org.networkcalculus.dnc.AnalysisConfig.MultiplexingEnforcement;
import org.networkcalculus.dnc.network.server_graph.Flow;
import org.networkcalculus.dnc.network.server_graph.ServerGraph;
import org.networkcalculus.dnc.numbers.Num;
import org.networkcalculus.dnc.tandem.analyses.PmooAnalysis;
import org.networkcalculus.dnc.tandem.analyses.SeparateFlowAnalysis;
import org.networkcalculus.dnc.tandem.analyses.TotalFlowAnalysis;

public class Analysis {

	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		FourTandem_ServerGraph network_factory = new FourTandem_ServerGraph();
		ServerGraph network = network_factory.getServerGraph();
		Set<Flow> s = new HashSet<>();
		s = network.getFlows();
		List<Flow> l = new ArrayList<>(s);
		//System.out.print(l.get(0).getAlias());
		//TotalFlowResults result = new TotalFlowResults();
		Flow fol = null;
		for(int j=0;j<l.size();j++) {
			if(l.get(j).getAlias() == "f1") {
				fol = l.get(j);
			}
		}
		Set<ArrivalBoundMethod> arrival_bound_methods = new HashSet<ArrivalBoundMethod>(Collections.singleton(ArrivalBoundMethod.AGGR_PBOO_CONCATENATION));
		AnalysisConfig configuration = new AnalysisConfig(MultiplexingEnforcement.GLOBAL_FIFO,MaxScEnforcement.SERVER_LOCAL,MaxScEnforcement.SERVER_LOCAL,arrival_bound_methods, true,false);	
		TotalFlowAnalysis tfa = new TotalFlowAnalysis(network, configuration);
		SeparateFlowAnalysis sfa = new SeparateFlowAnalysis(network, configuration);
		//PmooAnalysis pmoo = new PmooAnalysis(network, configuration);
		//pmoo.performAnalysis(fol);
		tfa.performAnalysis(fol);
		sfa.performAnalysis(fol);
		Num res1 = tfa.getDelayBound();
		Num res2 = sfa.getDelayBound();
		//Num res3 = pmoo.getDelayBound();
		System.out.println(res1);
		System.out.println(res2);
		//System.out.print(res3);

	}

}
