package implementation;
import java.util.LinkedList;
import java.util.List;

import org.networkcalculus.dnc.curves.ArrivalCurve;
import org.networkcalculus.dnc.curves.Curve;
import org.networkcalculus.dnc.curves.ServiceCurve;
import org.networkcalculus.dnc.network.server_graph.Flow;
import org.networkcalculus.dnc.network.server_graph.Server;
import org.networkcalculus.dnc.network.server_graph.ServerGraph;
import org.networkcalculus.dnc.network.server_graph.ServerGraphFactory;
import org.networkcalculus.dnc.network.server_graph.Turn;

public class OneSwitch_ServerGraph implements ServerGraphFactory{
	private final int sc_R = 100;
	private final double sc_T =  0.001;
	private final double ac_r = 1;
	private final double ac_b = 0.1;
	private ServiceCurve service_curve = Curve.getFactory().createRateLatency(sc_R, sc_T);
	private ArrivalCurve arrival_curve = Curve.getFactory().createTokenBucket(ac_r, ac_b);
	private ServerGraph server_graph;
	private Server s0;
	public OneSwitch_ServerGraph() {
		server_graph = createServerGraph();
	}
	@Override
	public ServerGraph createServerGraph() {
		// TODO Auto-generated method stub
		server_graph = new ServerGraph();

		s0 = server_graph.addServer(service_curve);


		try {
			server_graph.addFlow("f1", arrival_curve, s0);
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}

		return server_graph;
	}

	@Override
	public ServerGraph getServerGraph() {
		// TODO Auto-generated method stub
		return server_graph;
	}

	@Override
	public void reinitializeCurves() {
		// TODO Auto-generated method stub
		service_curve = Curve.getFactory().createRateLatency(sc_R, sc_T);
		for (Server server : server_graph.getServers()) {
			server.setServiceCurve(service_curve);
		}

		arrival_curve = Curve.getFactory().createTokenBucket(ac_r, ac_b);
		for (Flow flow : server_graph.getFlows()) {
			flow.setArrivalCurve(arrival_curve);
		}		
	}

}
